//+------------------------------------------------------------------+
//|                                               Envelopes - HL.mq4 |
//|                               Copyright  2011, Nikolaj Ostapujk |
//|                                                  nikost@inbox.lv |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 SlateBlue
#property indicator_color2 Coral
#property indicator_color3 SlateBlue
#property indicator_color4 Coral
extern double Deviation=0.14;
//---- indicator buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
//----
int ExtCountedBars=0,fast,slow;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,2);
   SetIndexStyle(1,DRAW_LINE,2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   IndicatorDigits(3);
   draw_begin=fast-1;
//---- indicator short name;
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
   SetIndexDrawBegin(2,draw_begin);
   SetIndexDrawBegin(3,draw_begin);
//---- indicator buffers mapping
   IndicatorBuffers(4);
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,Buffer2);
   SetIndexBuffer(2,Buffer3);
   SetIndexBuffer(3,Buffer4);
   fast=Bars/Period()*0.05;
   slow=1.4*fast;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   if(Bars<=fast) return(0);
   int    counted_bars=IndicatorCounted();
   if (counted_bars==0)   
      limit=Bars-1;
   if (counted_bars>0)      
      limit = Bars - counted_bars-1;
   for(int i=limit;i>=0;i--)
     { 
      Buffer1[i] = NormalizeDouble((1+Deviation/100)*iMA(NULL,0,fast,0,0,2,i),3);
      Buffer2[i] = NormalizeDouble((1-Deviation/100)*iMA(NULL,0,fast,0,0,3,i),3);
      Buffer3[i] = NormalizeDouble((1+Deviation*2/100)*iMA(NULL,0,slow,0,0,2,i),3);
      Buffer4[i] = NormalizeDouble((1-Deviation*2/100)*iMA(NULL,0,slow,0,0,3,i),3);
     }
 
   return(0);
  }
//+------------------------------------------------------------------+